SystemOrganization addCategory: #CompilerTests!

Parser subclass: #MockCustomParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

TestCase subclass: #ClosureCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/20/2008 09:40'!
methodWithCopiedAndAssignedTemps
	| blk "0w" a "0w" b "0w" c "0w" t "0w" r1 "0w" r2 "0w" |
	a := 1. "1w"
	b := 2. "1w"
	c := 4. "1w"
	t := 0. "1w"
	blk "5w" := ["2" t  "3w" := t "3r" + a "3r" + b "3r" + c "3r" ] "4".
	r1 "5w" := blk "5r" value.
	b "5w" := -100.
	r2 "5w" := blk "5r" value.
	^r1 "5r" -> r2 "5r" -> t "5r"

	"a: main(read(),write(0,1)), block(read(3),write()) => copy; no writes follow read
	 b: main(read(),write(0,1,5)), block(read(3),write()) => remote; write follows contained read
	 blk: main(read(5),write(0,5)), block(read(),write()) => no copy in blocks < 5
	 c: main(read(),write(0,1)), block(read(3),write()) => copy; no writes follow read
	 r1: main(read(5),write(0,5)), block(read(),write()) => no copy in blocks < 5
	 r2: main(read(5),write(0,5)), block(read(),write()) => no copy in blocks < 5
	 t: main(read(5),write(0,1)), block(read(3),write(3)) => remote; read follows contained write"


	"(Parser new
		encoderClass: EncoderForV3;
		parse: (self class sourceCodeAt: #methodWithCopiedAndAssignedTemps)
		class: self class) generateUsingClosures: #(0 0 0 0)"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 20:45'!
methodWithCopiedAndPostClosedOverAssignedTemps
	| blk a b c r1 r2 |
	a := 1.
	b := 2.
	c := 4.
	blk := [a + b + c].
	r1 := blk value.
	b := nil.
	r2 := blk value.
	r1 -> r2

	"(Parser new
		encoderClass: EncoderForV3;
		parse: (self class sourceCodeAt: #methodWithCopiedAndPostClosedOverAssignedTemps)
		class: self class) generateUsingClosures: #(0 0 0 0)"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 20:10'!
methodWithCopiedTemps
	| a b c r |
	a := 1.
	b := 2.
	c := 4.
	r := [a + b + c] value.
	b := nil.
	r

	"Parser new
		parse: (self class sourceCodeAt: #methodWithCopiedTemps)
		class: self class"

	"(Parser new
		encoderClass: EncoderForV3;
		parse: (self class sourceCodeAt: #methodWithCopiedTemps)
		class: self class) generateUsingClosures: #(0 0 0 0)"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 14:24'!
methodWithOptimizedBlocks
	| s c |
	s := self isNil
			ifTrue: [| a | a := 'isNil'. a]
			ifFalse: [| b | b := 'notNil'. b].
	c := String new: s size.
	1 to: s size do:
		[:i| c at: i put: (s at: i)].
	^c

	"Parser new
		parse: (self class sourceCodeAt: #methodWithOptimizedBlocks)
		class: self class"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 14:24'!
methodWithOptimizedBlocksA
	| s c |
	s := self isNil
			ifTrue: [| a | a := 'isNil'. a]
			ifFalse: [| a | a := 'notNil'. a].
	c := String new: s size.
	1 to: s size do:
		[:i| c at: i put: (s at: i)].
	^c

	"Parser new
		parse: (self class sourceCodeAt: #methodWithOptimizedBlocksA)
		class: self class"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 14:12'!
methodWithVariousTemps
	| classes total totalLength |
	classes := self withAllSuperclasses.
	total := totalLength := 0.
	classes do: [:class| | className |
		className := class name.
		total := total + 1.
		totalLength := totalLength + className size].
	^total -> totalLength

	"Parser new
		parse: (self class sourceCodeAt: #methodWithVariousTemps)
		class: self class"! !

!ClosureCompilerTest methodsFor: 'source' stamp: 'eem 7/1/2009 10:51'!
closureCases
	^#(
'| n |
n := 1.
^n + n'

'| i |
i := 0.
[i := i + 1.
 i <= 10] whileTrue.
^i'

'[:c :s| | mn |
mn := Compiler new
		compile: (c sourceCodeAt: s)
		in: c
		notifying: nil
		ifFail: [self halt].
mn generate: #(0 0 0 0).
{mn blockExtentsToTempsMap.
  mn encoder schematicTempNames}]
			value: AbstractInstructionTests
			value: #runBinaryConditionalJumps:'

'inject: thisValue into: binaryBlock
	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue'

'runBinaryConditionalJumps: assertPrintBar
	"CogIA32CompilerTests new runBinaryConditionalJumps: false"
	| mask reg1 reg2 reg3 |
	mask := 1 << self processor bitsInWord - 1.
	self concreteCompilerClass dataRegistersWithAccessorsDo:
		[:n :get :set|
		n = 0 ifTrue: [reg1 := get].
		n = 1 ifTrue: [reg2 := set].
		n = 2 ifTrue: [reg3 := set]].
	#(	(JumpAbove > unsigned)			(JumpBelowOrEqual <= unsigned)
		(JumpBelow < unsigned)			(JumpAboveOrEqual >= unsigned)
		(JumpGreater > signed)			(JumpLessOrEqual <= signed)
		(JumpLess < signed)				(JumpGreaterOrEqual >= signed)
		(JumpZero = signed)				(JumpNonZero ~= signed)) do:
		[:triple|
		[:opName :relation :signednessOrResult| | opcode jumpNotTaken jumpTaken nop memory bogus |
		self resetGen.
		opcode := CogRTLOpcodes classPool at: opName.
		self gen: CmpRR operand: 2 operand: 1.
		jumpTaken := self gen: opcode.
		self gen: MoveCqR operand: 0 operand: 0.
		jumpNotTaken := self gen: Jump.
		jumpTaken jmpTarget: (self gen: MoveCqR operand: 1 operand: 0).
		jumpNotTaken jmpTarget: (nop := self gen: Nop).
		memory := self generateInstructions.
		bogus := false.
		self pairs: (-2 to: 2)  do:
			[:a :b| | taken |
			self processor
				reset;
				perform: reg2 with: a signedIntToLong;
				perform: reg3 with: b signedIntToLong.
			[self processor singleStepIn: memory.
			 self processor pc ~= nop address] whileTrue.
			taken := (self processor perform: reg1) = 1.
			assertPrintBar
				ifTrue:
					[self assert: taken = (signednessOrResult == #unsigned
											ifTrue: [(a bitAnd: mask) perform: relation with: (b bitAnd: mask)]
											ifFalse: [a perform: relation with: b])]
				ifFalse:
					[Transcript
						nextPutAll: reg2; nextPut: $(; print: a; nextPutAll: '') ''; nextPutAll: relation; space;
						nextPutAll: reg3; nextPut: $(; print: b; nextPutAll: '') = '';
						print: taken; cr; flush.
					 taken = (signednessOrResult == #unsigned
											ifTrue: [(a bitAnd: mask) perform: relation with: (b bitAnd: mask)]
											ifFalse: [a perform: relation with: b]) ifFalse:
						[bogus := true]]].
			 bogus ifTrue:
				[self processor printRegistersOn: Transcript.
				 Transcript show: (self processor disassembleInstructionAt: jumpTaken address In: memory); cr]]
					valueWithArguments: triple]'

'mapFromBlockStartsIn: aMethod toTempVarsFrom: schematicTempNamesString constructor: aDecompilerConstructor
	| map |
	map := aMethod
				mapFromBlockKeys: aMethod startpcsToBlockExtents keys asSortedCollection
				toSchematicTemps: schematicTempNamesString.
	map keysAndValuesDo:
		[:startpc :tempNameTupleVector| | subMap tempVector numTemps |
		subMap := Dictionary new.
		"Find how many temp slots there are (direct & indirect temp vectors)
		 and for each indirect temp vector find how big it is."
		tempNameTupleVector do:
			[:tuple|
			tuple last isArray
				ifTrue:
					[subMap at: tuple last first put: tuple last last.
					 numTemps := tuple last first]
				ifFalse:
					[numTemps := tuple last]].
		"create the temp vector for this scope level."
		tempVector := Array new: numTemps.
		"fill it in with any indirect temp vectors"
		subMap keysAndValuesDo:
			[:index :size|
			tempVector at: index put: (Array new: size)].
		"fill it in with temp nodes."
		tempNameTupleVector do:
			[:tuple| | itv |
			tuple last isArray
				ifTrue:
					[itv := tempVector at: tuple last first.
					 itv at: tuple last last
						put: (aDecompilerConstructor
								codeTemp: tuple last last - 1
								named: tuple first)]
				ifFalse:
					[tempVector
						at: tuple last
						put: (aDecompilerConstructor
								codeTemp: tuple last - 1
								named: tuple first)]].
		"replace any indirect temp vectors with proper RemoteTempVectorNodes"
		subMap keysAndValuesDo:
			[:index :size|
			tempVector
				at: index
				put: (aDecompilerConstructor
						codeRemoteTemp: index
						remoteTemps: (tempVector at: index))].
		"and update the entry in the map"
		map at: startpc put: tempVector].
	^map'

 'gnuifyFrom: inFileStream to: outFileStream

"convert interp.c to use GNU features"

	| inData beforeInterpret inInterpret inInterpretVars beforePrimitiveResponse inPrimitiveResponse |

	inData := inFileStream upToEnd withSqueakLineEndings.
	inFileStream close.

	"print a header"
	outFileStream
		nextPutAll: ''/* This file has been post-processed for GNU C */'';
		cr; cr; cr.

	beforeInterpret := true.    "whether we are before the beginning of interpret()"
	inInterpret := false.     "whether we are in the middle of interpret"
	inInterpretVars := false.    "whether we are in the variables of interpret"
	beforePrimitiveResponse := true.  "whether we are before the beginning of primitiveResponse()"
	inPrimitiveResponse := false.   "whether we are inside of primitiveResponse"
	''Gnuifying''
		displayProgressAt: Sensor cursorPoint
		from: 1 to: (inData occurrencesOf: Character cr)
		during:
			[:bar | | lineNumber |
			lineNumber := 0.
			inData linesDo:
				[ :inLine | | outLine extraOutLine caseLabel |
				bar value: (lineNumber := lineNumber + 1).
				outLine := inLine. 	"print out one line for each input line; by default, print out the line that was input, but some rules modify it"
				extraOutLine := nil.   "occasionally print a second output line..."
				beforeInterpret ifTrue: [
					inLine = ''#include "sq.h"'' ifTrue: [
						outLine := ''#include "sqGnu.h"'' ].
					inLine = ''interpret(void) {'' ifTrue: [
						"reached the beginning of interpret"
						beforeInterpret := false.
						inInterpret := true.
						inInterpretVars := true ] ]
				ifFalse: [
				inInterpretVars ifTrue: [
					(inLine findString: ''register struct foo * foo = &fum;'') > 0 ifTrue: [
						outLine := ''register struct foo * foo FOO_REG = &fum;'' ].
					(inLine findString: '' localIP;'') > 0 ifTrue: [
						outLine := ''    char* localIP IP_REG;'' ].
					(inLine findString: '' localFP;'') > 0 ifTrue: [
						outLine := ''    char* localFP FP_REG;'' ].
					(inLine findString: '' localSP;'') > 0 ifTrue: [
						outLine := ''    char* localSP SP_REG;'' ].
					(inLine findString: '' currentBytecode;'') > 0 ifTrue: [
						outLine := ''    sqInt currentBytecode CB_REG;'' ].
					inLine isEmpty ifTrue: [
						"reached end of variables"
						inInterpretVars := false.
						outLine := ''    JUMP_TABLE;''.
						extraOutLine := inLine ] ]
				ifFalse: [
				inInterpret ifTrue: [
					"working inside interpret(); translate the switch statement"
					(inLine beginsWith: ''		case '') ifTrue: [
						caseLabel := (inLine findTokens: ''	 :'') second.
						outLine := ''		CASE('', caseLabel, '')'' ].
					inLine = ''			break;'' ifTrue: [
						outLine := ''			BREAK;'' ].
					inLine = ''}'' ifTrue: [
						"all finished with interpret()"
						inInterpret := false ] ]
				ifFalse: [
				beforePrimitiveResponse ifTrue: [
					(inLine beginsWith: ''primitiveResponse('') ifTrue: [
						"into primitiveResponse we go"
						beforePrimitiveResponse := false.
						inPrimitiveResponse := true.
						extraOutLine := ''    PRIM_TABLE;'' ] ]
				ifFalse: [
				inPrimitiveResponse ifTrue: [
					inLine = ''	switch (primitiveIndex) {'' ifTrue: [
						extraOutLine := outLine.
						outLine := ''	PRIM_DISPATCH;'' ].
					inLine = ''	switch (GIV(primitiveIndex)) {'' ifTrue: [
						extraOutLine := outLine.
						outLine := ''	PRIM_DISPATCH;'' ].
					(inLine beginsWith: ''	case '') ifTrue: [
						caseLabel := (inLine findTokens: ''	 :'') second.
						outLine := ''	CASE('', caseLabel, '')'' ].
					inLine = ''}'' ifTrue: [
						inPrimitiveResponse := false ] ]
				] ] ] ].

				outFileStream nextPutAll: outLine; cr.
				extraOutLine ifNotNil: [
					outFileStream nextPutAll: extraOutLine; cr ]]].

	outFileStream close' )! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/24/2008 12:28'!
doTestDebuggerTempAccessWith: one with: two
	"Test debugger access for temps"
	| outerContext local1 remote1 |
	outerContext := thisContext.
	local1 := 3.
	remote1 := 1/2.
	self assert: (Compiler new evaluate: 'one' in: thisContext to: self) == one.
	self assert: (Compiler new evaluate: 'two' in: thisContext to: self) == two.
	self assert: (Compiler new evaluate: 'local1' in: thisContext to: self) == local1.
	self assert: (Compiler new evaluate: 'remote1' in: thisContext to: self) == remote1.
	Compiler new evaluate: 'local1 := -3.0' in: thisContext to: self.
	self assert: local1 = -3.0.
	(1 to: 2) do:
		[:i| | local2 r1 r2 r3 r4 |
		local2 := i * 3.
		remote1 := local2 / 7.
		self assert: thisContext ~~ outerContext.
		self assert: (r1 := Compiler new evaluate: 'one' in: thisContext to: self) == one.
		self assert: (r2 := Compiler new evaluate: 'two' in: thisContext to: self) == two.
		self assert: (r3 := Compiler new evaluate: 'i' in: thisContext to: self) == i.
		self assert: (r4 := Compiler new evaluate: 'local2' in: thisContext to: self) == local2.
		self assert: (r4 := Compiler new evaluate: 'remote1' in: thisContext to: self) == remote1.
		self assert: (r4 := Compiler new evaluate: 'remote1' in: outerContext to: self) == remote1.
		Compiler new evaluate: 'local2 := 15' in: thisContext to: self.
		self assert: local2 = 15.
		Compiler new evaluate: 'local1 := 25' in: thisContext to: self.
		self assert: local1 = 25.
		{ r1. r2. r3. r4 } "placate the compiler"].
	self assert: local1 = 25.
	self assert: remote1 = (6/7)! !

!ClosureCompilerTest methodsFor: 'testing' stamp: 'AdrianLienhard 10/19/2009 09:31'!
expectedFailures
	"The problem in the tests #testDebuggerTempAccess is that a compiler evaluate
	message is sent and this prevents the proper temp analysis of the closure compiler"
	
	^#(testDebuggerTempAccess testInjectIntoDecompilations testInjectIntoDecompiledDebugs)! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 16:58'!
supportTestSourceRangeAccessForDecompiledInjectInto: method source: source
	"Test debugger source range selection for inject:into:"
	^self
		supportTestSourceRangeAccessForInjectInto: method
		source: source
		selectionSequence: #(	':= t1'
								'do: [:t4 | t3 := t2 value: t3 value: t4]'
								'value: t3 value: t4'
								':= t2 value: t3 value: t4'
								']'
								'value: t3 value: t4'
								':= t2 value: t3 value: t4'
								']'
								'^t3')! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 19:44'!
supportTestSourceRangeAccessForDecompiledNoBytecodeInjectInto: method source: source
	"Test debugger source range selection for inject:into:"
	^self
		supportTestSourceRangeAccessForInjectInto: method
		source: source
		selectionSequence: #(	'at: 1 put: t1'
								'do: [:t4 | t3 at: 1 put: (t2 value: (t3 at: 1) value: t4)]'
								'value: (t3 at: 1) value: t4'
								'at: 1 put: (t2 value: (t3 at: 1) value: t4)'
								']'
								'value: (t3 at: 1) value: t4'
								'at: 1 put: (t2 value: (t3 at: 1) value: t4)'
								']'
								'^t3 at: 1')! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'StephaneDucasse 3/15/2010 21:24'!
supportTestSourceRangeAccessForInjectInto: method source: source
	"Test debugger source range selection for inject:into:"
	^self
		supportTestSourceRangeAccessForInjectInto: method
		source: source
		selectionSequence: #(	':= thisValue'
								'do: [:each | nextValue := binaryBlock value: nextValue value: each]'
								'value: nextValue value: each'
								':= binaryBlock value: nextValue value: each'
								'nextValue := binaryBlock value: nextValue value: each'
								'value: nextValue value: each'
								':= binaryBlock value: nextValue value: each'
								'nextValue := binaryBlock value: nextValue value: each'
								'^nextValue')! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 7/29/2008 17:16'!
supportTestSourceRangeAccessForInjectInto: method source: source selectionSequence: selections
	"Test debugger source range selection for inject:into:"
	| evaluationCount sourceMap debugTokenSequence debugCount |
	DebuggerMethodMap voidMapCache.
	evaluationCount := 0.
	sourceMap := method debuggerMap abstractSourceMap.
	debugTokenSequence := selections collect: [:string| Scanner new scanTokens: string].
	debugCount := 0.
	thisContext
		runSimulated: [(1 to: 2)
						withArgs:
							{	0.
								[:sum :each|
								 evaluationCount := evaluationCount + 1.
								 sum + each]}
						executeMethod: method]
		contextAtEachStep:
			[:ctxt| | range debugTokens |
			(ctxt method == method
			and: ["Exclude the send of #blockCopy: or #closureCopy:copiedValues: and braceWith:with:
				    to create the block, and the #new: and #at:'s for the indirect temp vector.
				   This for compilation without closure bytecodes. (Note that at:put:'s correspond to stores)"
				(ctxt willSend
					and: [(#(closureCopy:copiedValues: blockCopy: new: at: braceWith:with:) includes: ctxt selectorToSendOrSelf) not])
				"Exclude the store of the argument into the home context (for BlueBook blocks)
				 and the store of an indirection vector into an initial temp"
				or: [(ctxt willStore
					and: [(ctxt isBlock and: [ctxt pc = ctxt startpc]) not
					and: [(ctxt isBlock not
						and: [(method usesClosureBytecodes and: [ctxt abstractPC = 2])]) not]])
				or: [ctxt willReturn]]]) ifTrue:
				[debugTokens := debugTokenSequence at: (debugCount := debugCount + 1) ifAbsent: [#(bogusToken)].
				 self assert: (sourceMap includesKey: ctxt abstractPC).
				 range := sourceMap at: ctxt abstractPC ifAbsent: [(1 to: 0)].
				 self assert: (Scanner new scanTokens: (source copyFrom: range first to: range last)) = debugTokens]].
	self assert: evaluationCount = 2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'HenrikSperreJohansen 5/27/2010 14:01'!
testBlockDoitDecompilation
	"Tests that decompile of a doit block with remote vars executes correcly"
	"Tests that decompilation of a Block, when 'method' of block is equivalent to that compiled by a DoIt, preserves the temp names "
	
	|blockSourceStream methodNode compiledMethod block decompiledBlock|
	blockSourceStream := '|x y| [:a :b | x := a. y := b. x + y]' readStream.
	methodNode := nil class evaluatorClass new 
						from: blockSourceStream class: nil class context: nil notifying: nil;
						translate: blockSourceStream noPattern: true ifFail: [nil].
	compiledMethod := methodNode generateWithTempNames.
	block := nil withArgs: #() executeMethod: compiledMethod.
	
	self shouldnt: [decompiledBlock := block decompile] raise: Error.
	self assert: '{[:a :b | 
x := a.
	y := b.
	x + y]}' equals: decompiledBlock printString
! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'nice 1/16/2010 18:49'!
testBlockNumbering
	"Test that the compiler and CompiledMethod agree on the block numbering of a substantial doit."
	"self new testBlockNumbering"
	| methodNode method tempRefs |
	methodNode :=
		Parser new
			encoderClass: EncoderForV3PlusClosures;
			parse: 'foo
					| numCopiedValuesCounts |
					numCopiedValuesCounts := Dictionary new.
					0 to: 32 do: [:i| numCopiedValuesCounts at: i put: 0].
					Transcript clear.
					Smalltalk allClasses remove: GeniePlugin; do:
						[:c|
						{c. c class} do:
							[:b|
							Transcript nextPut: b name first; endEntry.
							b selectorsAndMethodsDo:
								[:s :m| | pn |
								m isQuick not ifTrue:
									[pn := b parserClass new
												encoderClass: EncoderForV3PlusClosures;
												parse: (b sourceCodeAt: s)
												class: b.
									 pn generate.
									 [pn accept: nil]
										on: MessageNotUnderstood
										do: [:ex| | msg numCopied |
											msg := ex message.
											(msg selector == #visitBlockNode:
											 and: [(msg argument instVarNamed: ''optimized'') not]) ifTrue:
												[numCopied := (msg argument computeCopiedValues: pn) size.
												 numCopiedValuesCounts
													at: numCopied
													put: (numCopiedValuesCounts at: numCopied) + 1].
											msg setSelector: #==.
											ex resume: nil]]]]].
					numCopiedValuesCounts'
			class: Object.
	method := methodNode generate.
	tempRefs := methodNode encoder blockExtentsToTempsMap.
	self assert: tempRefs keys asSet = method startpcsToBlockExtents values asSet! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'nice 1/16/2010 17:12'!
testBlockNumberingForInjectInto
	"Test that the compiler and CompiledMethod agree on the block numbering of Collection>>inject:into:
	 and that temp names for inject:into: are recorded."
	"self new testBlockNumberingForInjectInto"
	| methodNode method tempRefs |
	methodNode := Parser new
						encoderClass: EncoderForV3PlusClosures;
						parse: (Collection sourceCodeAt: #inject:into:)
						class: Collection.
	method := methodNode generate.
	tempRefs := methodNode encoder blockExtentsToTempsMap.
	self assert: tempRefs keys asSet = method startpcsToBlockExtents values asSet.
	self assert: ((tempRefs includesKey: (0 to: 6))
				and: [((tempRefs at: (0 to: 6)) collect: [:e | e first]) hasEqualElements: {'thisValue'. 'binaryBlock'. 'nextValue'}]).
	self assert: ((tempRefs includesKey: (2 to: 4))
				and: [((tempRefs at: (2 to: 4)) collect: [:e | e first])  hasEqualElements: {'each'. 'binaryBlock'.  'nextValue'}])! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/24/2008 11:03'!
testDebuggerTempAccess
	self doTestDebuggerTempAccessWith: 1 with: 2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'Igor.Stasenko 12/20/2009 07:19'!
testDecompiledDoitMethodTempNames
	"self new testDecompiledDoitMethodTempNames"
	"Test that a decompiled doit that has been copied with temps decompiles to the input"
	| removeComments |
	removeComments := [:n| n comment: nil].
	self closureCases do:
		[:source| | mns m mps mnps |
		"Need to compare an ungenerated tree with the generated method's methodNode
		 because generating code alters the tree when it introduces remote temp vectors."
		mns := #(first last) collect:
					[:ignored|
					source first isLetter
						ifTrue:
							[self class compilerClass new
								compile: source
								in: self class
								notifying: nil
								ifFail: [self error: 'compilation error']]
						ifFalse:
							[self class compilerClass new
								compileNoPattern: source
								in: self class
								context: nil
								notifying: nil
								ifFail: [self error: 'compilation error']]].
		m := (mns last generateWithTempNames).
		removeComments value: mns first.
		mns first nodesDo: removeComments.
		self assert: (mnps := mns first printString) = (mps := m methodNode printString)]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'nice 1/16/2010 18:47'!
testInjectIntoDecompilations
	"Test various compilations decompile to the same code for a method sufficiently
	 simple that this is possible and sufficiently complex that the code generated
	 varies between the compilations."
	"self new testInjectIntoDecompilations"
	| source |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	{ Encoder.
	   EncoderForV3. EncoderForLongFormV3.
	   EncoderForV3PlusClosures. EncoderForLongFormV3PlusClosures } do:
		[:encoderClass| | method |
		method := (Parser new
							encoderClass: encoderClass;
							parse: source
							class: Collection)
						generate.
		self assert: (Scanner new scanTokens: method decompileString)
					= #(inject: t1 into: t2
							| t3 |
							t3 ':=' t1 .
							self do: [ ':t4' | t3 ':=' t2 value: t3 value: t4 ] .
							^ t3)]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'nice 1/16/2010 18:47'!
testInjectIntoDecompiledDebugs
	"Test various debugs of the decompiled form debug correctly."
	"self new testInjectIntoDecompiledDebugs"
	| source |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	{ Encoder.
	   EncoderForV3PlusClosures. EncoderForLongFormV3PlusClosures } do:
		[:encoderClass| | method |
		method := (Parser new
							encoderClass: encoderClass;
							parse: source
							class: Collection)
						generate.
		self supportTestSourceRangeAccessForDecompiledInjectInto: method source: method decompileString]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 7/24/2009 11:51'!
testInlineBlockCollectionEM1
	| a1 b1 i1 a2 b2 i2 we wb |
	b1 := OrderedCollection new.
	i1 := 1.
	[a1 := i1.
	 i1 <= 3] whileTrue:
		[b1 add: [a1].
		i1 := i1 + 1].
	b1 := b1 asArray collect: [:b | b value].
	b2 := OrderedCollection new.
	i2 := 1.
	we := [a2 := i2. i2 <= 3].
	wb := [b2 add: [a2]. i2 := i2 + 1].
	we whileTrue: wb. "defeat optimization"
	b2 := b2 asArray collect: [:b | b value].
	self assert: b1 = b2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 3/7/2009 11:25'!
testInlineBlockCollectionLR1
	"Test case from Lukas Renggli"
	| col |
	col := OrderedCollection new.
	1 to: 11 do: [ :each | col add: [ each ] ].
	self assert: (col collect: [ :each | each value ]) asArray = (1 to: 11) asArray! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 3/7/2009 11:39'!
testInlineBlockCollectionLR2
	"Test case from Lukas Renggli"
	| col |
	col := OrderedCollection new.
	1 to: 11 do: [ :each | #(1) do: [:ignored| col add: [ each ]] ].
	self assert: (col collect: [ :each | each value ]) asArray = (1 to: 11) asArray! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 3/9/2009 11:00'!
testInlineBlockCollectionLR3
	| col |
	col := OrderedCollection new.
	1 to: 11 do: [ :each | | i | i := each. col add: [ i ]. i := i + 1 ].
	self assert: (col collect: [ :each | each value ]) asArray = (2 to: 12) asArray! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 7/22/2009 16:55'!
testInlineBlockCollectionSD1
	| a1 b1 a2 b2 |
	b1 := OrderedCollection new.
	1 to: 3 do:
		[:i |
		a1 := i.
		b1 add: [a1]].
	b1 := b1 asArray collect: [:b | b value].
	b2 := OrderedCollection new.
	1 to: 3 do:
		[:i |
		a2 := i.
		b2 add: [a2]] yourself. "defeat optimization"
	b2 := b2 asArray collect: [:b | b value].
	self assert: b1 = b2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'Igor.Stasenko 12/20/2009 03:57'!
testMethodAndNodeTempNames
	"self new testMethodAndNodeTempNames"
	"Test that BytecodeAgnosticMethodNode>>blockExtentsToTempRefs answers the same
	 structure as CompiledMethod>>blockExtentsToTempRefs when the method has been
	 copied with the appropriate temps.  This tests whether doit methods are debuggable
	 since they carry their own temps."
	self closureCases do:
		[:source| | mn om m mbe obe |
		mn := source first isLetter
					ifTrue:
						[self class compilerClass new
							compile: source
							in: self class
							notifying: nil
							ifFail: [self error: 'compilation error']]
					ifFalse:
						[self class compilerClass new
							compileNoPattern: source
							in: self class
							context: nil
							notifying: nil
							ifFail: [self error: 'compilation error']].
		m := (om := mn generate) copyWithTempsFromMethodNode: mn.
		self assert: m holdsTempNames.
		self assert: m endPC = om endPC.
		mbe := m blockExtentsToTempsMap.
		obe := mn blockExtentsToTempsMap.
		self assert: mbe keys asSet = obe keys asSet.
		(mbe keys intersection: obe keys) do:
			[:interval|
			self assert: (mbe at: interval) = (obe at: interval)]]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 15:20'!
testSourceRangeAccessForBlueBookInjectInto
	"Test debugger source range selection for inject:into: for a version compiled with closures"
	"self new testSourceRangeAccessForBlueBookInjectInto"
	| source method |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	method := (Parser new
						encoderClass: EncoderForV3;
						parse: source
						class: Collection)
					generate: (Collection compiledMethodAt: #inject:into:) trailer.
	self supportTestSourceRangeAccessForInjectInto: method source: source! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 15:20'!
testSourceRangeAccessForBlueBookLongFormInjectInto
	"Test debugger source range selection for inject:into: for a version compiled with closures"
	"self new testSourceRangeAccessForBlueBookLongFormInjectInto"
	| source method |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	method := (Parser new
						encoderClass: EncoderForLongFormV3;
						parse: source
						class: Collection)
					generate: (Collection compiledMethodAt: #inject:into:) trailer.
	self supportTestSourceRangeAccessForInjectInto: method source: source! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 15:20'!
testSourceRangeAccessForClosureBytecodeInjectInto
	"Test debugger source range selection for inject:into: for a version compiled with closures"
	"self new testSourceRangeAccessForClosureBytecodeInjectInto"
	| source method |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	method := (Parser new
						encoderClass: EncoderForV3PlusClosures;
						parse: source
						class: Collection)
					generate: (Collection compiledMethodAt: #inject:into:) trailer.
	self supportTestSourceRangeAccessForInjectInto: method source: source! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 15:20'!
testSourceRangeAccessForClosureLongFormBytecodeInjectInto
	"Test debugger source range selection for inject:into: for a version compiled with closures"
	"self new testSourceRangeAccessForClosureLongFormBytecodeInjectInto"
	| source method |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	method := (Parser new
						encoderClass: EncoderForLongFormV3PlusClosures;
						parse: source
						class: Collection)
					generate: (Collection compiledMethodAt: #inject:into:) trailer.
	self supportTestSourceRangeAccessForInjectInto: method source: source! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 11:40'!
testSourceRangeAccessForInjectInto
	"Test debugger source range selection for inject:into: for the current version of the method"
	"self new testSourceRangeAccessForInjectInto"
	self supportTestSourceRangeAccessForInjectInto: (Collection compiledMethodAt: #inject:into:)
		source: (Collection sourceCodeAt: #inject:into:) asString! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'nice 1/16/2010 17:01'!
testTempNameAccessForInjectInto
	"self new testTempNameAccessForInjectInto"
	| methodNode method evaluationCount block debuggerMap |
	methodNode := Parser new
						encoderClass: EncoderForV3PlusClosures;
						parse: (Collection sourceCodeAt: #inject:into:)
						class: Collection.
	method := methodNode generate.
	debuggerMap := DebuggerMethodMap forMethod: method methodNode: methodNode.
	evaluationCount := 0.
	block := [:prev :each| | theContext tempNames |
			evaluationCount := evaluationCount + 1.
			theContext := thisContext sender.
			tempNames := debuggerMap tempNamesForContext: theContext.
			self assert: (tempNames hasEqualElements: tempNames).
			#('thisValue' 'each' 'binaryBlock' 'nextValue')
				with: { 0. each. block. prev}
				do: [:tempName :value|
					self assert: (debuggerMap namedTempAt: (tempNames indexOf: tempName) in: theContext) == value.
					tempName ~= 'each' ifTrue:
						[self assert: (debuggerMap namedTempAt: (tempNames indexOf: tempName) in: theContext home) == value]]].
	(1 to: 10) withArgs: { 0. block } executeMethod: method.
	self assert: evaluationCount = 10! !

TestCase subclass: #CompilerEvaluationTest
	instanceVariableNames: 'weightedAverage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!CompilerEvaluationTest commentStamp: 'StephaneDucasse 6/9/2010 20:54' prior: 0!
This test is important since it covers a bug of during the debugging of super
binding. 
It uses the class AverageCost/TotalCost and WeightedAverageCost.!

!CompilerEvaluationTest methodsFor: 'helper methods' stamp: 'carlaGriggio 5/22/2010 21:24'!
method
	^self methodContext method asString
! !

!CompilerEvaluationTest methodsFor: 'helper methods' stamp: 'StephaneDucasse 6/9/2010 20:55'!
methodContext
	| process |
	process := [ self weightedAverage total ] newProcess.
	[ process step ] doWhileTrue: [ process suspendedContext method selector ~= #total ].
	^ process suspendedContext! !

!CompilerEvaluationTest methodsFor: 'helper methods' stamp: 'carlaGriggio 5/22/2010 21:24'!
model
	^Debugger context: self methodContext ! !

!CompilerEvaluationTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/9/2010 20:55'!
setUp
	weightedAverage := WeightedAverageCost new ! !

!CompilerEvaluationTest methodsFor: 'testing' stamp: 'StephaneDucasse 3/1/2011 19:29'!
testEvaluationOfSelfSend
	"Tests the evaluation of an inherited method that uses super send
	and self send"
	"self debug: #testEvaluationOfSelfSend"
	| result editor |
	editor := self method asText asMorph editor.
	result := Compiler new
				evaluate: (self method copyFrom: 6 to: self method size)
				in: self model doItContext
				to: self model doItReceiver
				notifying: editor 
				ifFail: [^ #failedDoit]
				logged: true.
	self assert: result = (6250 / 3)! !

!CompilerEvaluationTest methodsFor: 'helper methods' stamp: 'carlaGriggio 5/23/2010 20:18'!
weightedAverage 
	^weightedAverage ! !

TestCase subclass: #CompilerExceptionsTest
	instanceVariableNames: 'status text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!CompilerExceptionsTest methodsFor: 'compiling' stamp: 'StephaneDucasse 2/10/2011 16:59'!
compile: sourceString

       text := sourceString.
       self class
               compileSilently: text
               classified: 'generated'
               notifying: self! !

!CompilerExceptionsTest methodsFor: 'compiling' stamp: 'StephaneDucasse 2/10/2011 17:00'!
compiling: sourceCode shouldRaise: exceptionClass

	self should: [ self compile: sourceCode ] raise: exceptionClass! !

!CompilerExceptionsTest methodsFor: 'compiling' stamp: 'StephaneDucasse 2/10/2011 17:01'!
removeGeneratedMethods

	self class removeCategory: 'generated'! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'cwp 8/25/2009 20:23'!
select
	! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'cwp 8/25/2009 20:23'!
selectFrom: start to: end 
	! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'cwp 8/25/2009 20:22'!
selectionInterval
	^ 1 to: 0! !

!CompilerExceptionsTest methodsFor: 'setUp' stamp: 'StephaneDucasse 2/10/2011 17:35'!
setUp

	self removeGeneratedMethods.
	status := Parser warningAllowed.
	Parser warnUser.! !

!CompilerExceptionsTest methodsFor: 'setUp' stamp: 'StephaneDucasse 3/15/2010 21:11'!
tearDown
	
	Parser warningAllowed: status
	! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'StephaneDucasse 2/10/2011 17:28'!
testAmbiguousSelector

       self
               compiling: 'griffle ^1--1'
               shouldRaise: AmbiguousSelector;
               compiling: 'griffle ^1@-1'
               shouldRaise: AmbiguousSelector;
               compiling: 'griffle ^1+-1'
               shouldRaise: AmbiguousSelector! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'StephaneDucasse 2/10/2011 17:29'!
testUndeclaredVariable

	self
		compiling: 'griffle ^ goo' shouldRaise: UndeclaredVariable;
		compiling: 'griffle ^ [ goo ] value' shouldRaise: UndeclaredVariable! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'StephaneDucasse 2/10/2011 17:30'!
testUndefinedVariable

	self
		compiling: 'griffle | goo | ^ goo' shouldRaise: UndefinedVariable;
		compiling: 'griffle [ | goo | ^ goo ] value' shouldRaise: UndefinedVariable! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'StephaneDucasse 2/10/2011 17:30'!
testUnknownSelector

	self
		compiling: 'griffle self reallyHopeThisIsntImplementedAnywhere' shouldRaise: UnknownSelector;
		compiling: 'griffle [ self reallyHopeThisIsntImplementedAnywhere ] value' shouldRaise: UnknownSelector! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'StephaneDucasse 2/10/2011 17:37'!
testUnusedVariable

       self
               compiling: 'griffle | goo | ^nil' shouldRaise: UnusedVariable.

	" does not work for the moment.
      self       compiling: 'griffle ^[ | goo | ]' shouldRaise: UnusedVariable
	"! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'StephaneDucasse 2/10/2011 17:36'!
text
	^ text! !

TestCase subclass: #ContextCompilationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!ContextCompilationTest methodsFor: 'tests' stamp: 'eem 6/19/2008 10:11'!
testVariablesAndOffsetsDo

	"ContextCompilationTest new testVariablesAndOffsetsDo"
	| contextClasses |
	contextClasses := ContextPart withAllSuperclasses, ContextPart allSubclasses asArray.
	contextClasses do:
		[:class|
		class variablesAndOffsetsDo:
			[:var :offset|
			self assert: offset < 0.
			self assert: (class instVarNameForIndex: offset negated) == var]].

	InstructionStream withAllSuperclasses, InstructionStream allSubclasses asArray do:
		[:class|
		(contextClasses includes: class) ifFalse:
			[class variablesAndOffsetsDo:
				[:var :offset|
				(InstructionStream instVarNames includes: var) ifFalse:
					[self assert: offset > 0.
					 self assert: (class instVarNameForIndex: offset) == var]]]]! !

TestCase subclass: #CustomParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!CustomParserTest class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/10/2011 19:03'!
parserClass

	^ MockCustomParser! !

!CustomParserTest methodsFor: 'tests' stamp: 'StephaneDucasse 1/12/2011 15:42'!
testCustomParser
	"Test whether the compiler uses a custom parser class to parse the source code. This custom parser class is answered by the   class side #parserClass message, instead of default one"
	"self debug: #testCustomParser"
	
	| compiler result |
	compiler := self class compilerClass new.

	"let compiler initialize its class ivar"
	result := compiler parse: ' a ^1 + 1' in: self class notifying: nil.
	
	self assert: compiler parserClass == MockCustomParser
	! !

TestCase subclass: #ScannerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!ScannerTests methodsFor: 'testing' stamp: 'nice 4/4/2010 21:56'!
testAmbiguousSelector
	"Non regression test.
	See http://code.google.com/p/pharo/issues/detail?id=2271
	and http://bugs.squeak.org/view.php?id=7491"
	
	self shouldnt: [Scanner new scanTokens: '1@-1'] raise: Error.
	self assert: ((Scanner new scanTokens: '1@-1') at: 2) asString = '@-'! !

LongTestCase subclass: #DecompilerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!DecompilerTests commentStamp: 'sd 9/26/2004 13:24' prior: 0!
Apparently the decompiler does not really work totally.
Here are a bunch of methods that can help improving the decompiler:
	- blockingClasses return class for which it is impossible to decompile methods 
	- failures are problems that lead to a DNU
	- decompilerDiscrepancies are the results of running decompileTestHelper..as you see the pattern 	
	is quite present.!

!DecompilerTests methodsFor: 'utilities' stamp: 'JB 10/18/2010 14:34'!
checkDecompileMethod: oldMethod

       | cls selector oldMethodNode methodNode newMethod oldCodeString newCodeString |
       cls := oldMethod methodClass.
       selector := oldMethod selector.
       oldMethodNode := (cls decompilerClass new withTempNames: oldMethod methodNode schematicTempNamesString)
                                               decompile: selector
                                               in: cls
                                               method: oldMethod.
       [oldMethodNode properties includesKey: #warning] whileTrue:
               [oldMethodNode properties removeKey: #warning].
       oldCodeString := oldMethodNode decompileString.
       methodNode := [cls compilerClass new
                                               compile: oldCodeString
                                               in: cls
                                               notifying: nil
                                               ifFail: []]
                                               on: SyntaxErrorNotification
                                               do: [:ex|
                                                       ex errorMessage = 'Cannot store into' ifTrue:
                                                               [ex return: #badStore].
                                                       ex pass].
       "Ignore cannot store into block arg errors; they're not our issue."
       methodNode ~~ #badStore ifTrue:
               [newMethod := methodNode generate.
                newCodeString := ((cls decompilerClass new withTempNames: methodNode schematicTempNamesString)
                                                       decompile: selector
                                                       in: cls
                                                       method: newMethod) decompileString.
                "(StringHolder new textContents:
                       (TextDiffBuilder buildDisplayPatchFrom: oldCodeString to: newCodeString))
                               openLabel: 'Decompilation Differences for ', cls name,'>>',selector"
                "(StringHolder new textContents:
                       (TextDiffBuilder buildDisplayPatchFrom: oldMethod abstractSymbolic to: newMethod abstractSymbolic))
                               openLabel: 'Bytecode Differences for ', cls name,'>>',selector"
                self assert: oldCodeString = newCodeString
                       description: cls name asString, ' ', selector asString
                       resumable: true]! !

!DecompilerTests methodsFor: 'utilities' stamp: 'JB 10/18/2010 14:36'!
classNames
       | base41packageCategories classNames |
       "(SystemOrganization categories collect: [:ea| (ea copyUpTo: $-) asString]) asSet asSortedCollection asArray"
       base41packageCategories :=
               #(      '311Deprecated'
                       'Balloon'
                       'Collections' 'CollectionsTests' 'Compiler' 'Compression'
                       'Etoys' 'Exceptions'
                       'Files'
                       'Graphics' 'GraphicsTests'
                       'Help' 'HelpSystem'
                       'Installer'
                       'Kernel' 'KernelTests'
                        'Monticello' 'MonticelloConfigurations' 'Morphic' 'MorphicExtras' 'MorphicTests' 'Multilingual' 'MultilingualTests'
                       'Nebraska' 'Network' 'NetworkTests'
                       'PackageInfo' 'PreferenceBrowser' 'Protocols'
                       'ReleaseBuilder'
                       'SMBase' 'SMLoader' 'ST80' 'SUnit' 'SUnitGUI' 'ScriptLoader' 'Services' 'ShoutCore' 'Simulation' 'Sound' 'System' 'SystemChangeNotification'
                       'Tests' 'ToolBuilder' 'Tools' 'ToolsTests' 'Traits' 'TraitsTests' 'TrueType'
                       'Universes'
                       'VersionNumber' 'VersionNumberTests'
                       'XML') asSet.
       classNames := Set new.
       SystemOrganization categories do:
              [:cat|
               (base41packageCategories includes: (cat copyUpTo: $-) asString) ifTrue:
                       [classNames addAll: (SystemOrganization listAtCategoryNamed: cat)]].
       ^classNames asSortedCollection! !

!DecompilerTests methodsFor: 'utilities' stamp: 'JB 10/18/2010 14:41'!
decompileClassesSelect: aBlock

       (self classNames select: aBlock) do:
               [:cn | | cls |
               cls := Smalltalk globals at: cn.
               cls selectorsAndMethodsDo:
                      [:selector :meth |
                       (self isFailure: cls sel: selector) ifFalse:
                              [self checkDecompileMethod: meth]]]
! !

!DecompilerTests methodsFor: 'utilities' stamp: 'JB 10/18/2010 14:42'!
decompileStringForParseTree: aMethodNode
       "Renumber the temps in the tree in parse tree order to eliminate that as a source of extraneous difference."
       | visited count counter |
       visited := IdentitySet new.
       count := 0.
       counter := [:temp|
                               (visited includes: temp) ifFalse:
                                       [temp name: 't', (count := count + 1) printString.
                                        visited add: temp]].
       aMethodNode nodesDo:
               [:node|
               (node == aMethodNode or: [node isBlockNode and: [node optimized not]]) ifTrue:
                       [node arguments do: counter].
               node isTemp ifTrue:
                      [counter value: node]].
      aMethodNode nodesDo:
              [:node|
               (node == aMethodNode or: [node isBlockNode and: [node optimized not]]) ifTrue:
                       [node temporaries do: counter.
                        node temporaries: (node temporaries asSortedCollection: ParseNode tempSortBlock) asArray]].
      ^aMethodNode decompileString! !

!DecompilerTests methodsFor: 'utilities' stamp: 'StephaneDucasse 1/28/2011 16:30'!
decompilerDiscrepancies
	"classnames, method selector, isMeta"

	^  #(#(#AIFFFileReader #readExtendedFloat false) #(#AbstractFont #emphasisStringFor: false) #(#AbstractString #asSmalltalkComment false) #(#AbstractString #compressWithTable: false) #(#AbstractString #howManyMatch: false) #(#Archive #addTree:removingFirstCharacters: false) #(#ArchiveViewer #createButtonBar false) #(#ArchiveViewer #extractAllPossibleInDirectory: false) #(#BMPReadWriter #nextPutImage: false) #(#Bitmap #readCompressedFrom: false) #(#BitmapStreamTests #testOtherClasses false) #(#BlobMorph #mergeSelfWithBlob:atPoint: false) #(#BookMorph #fromRemoteStream: false) #(#BookMorph #saveIndexOfOnly: false) #(#Browser #categorizeAllUncategorizedMethods false) #(#Browser #highlightMessageList:with: false) #(#Categorizer #elementCategoryDict false) #(#ChangeList #selectConflicts: false) #(#ChangeSet #containsMethodAtPosition: false) #(#ChangeSorter #removeContainedInClassCategories false) #(#CodeHolder #getSelectorAndSendQuery:to:with: false) #(#Color #initializeGrayToIndexMap false) #(#ColorForm #maskingMap false) #(#CompiledMethodInspector #fieldList false) #(#ComplexBorder #drawLineFrom:to:on: false) #(#DateAndTime #ticks:offset: false) #(#Dictionary #scanFor: false) #(#DockingBarMorph #example3 false) #(#Envelope #storeOn: false) #(#FFT #transformDataFrom:startingAt: false) #(#FMSound #mixSampleCount:into:startingAt:leftVol:rightVol: false) #(#FTPClient #getDataInto: false) #(#FWT #samples: false) #(#FWT #setAlpha:beta: false) #(#FileList #selectEncoding false) #(#FileList2 #endingSpecs false) #(#FilePackage #conflictsWithUpdatedMethods false) #(#FishEyeMorph #calculateTransform false) #(#FlapsTest #testRegisteredFlapsQuads false) #(#Float #absPrintExactlyOn:base: false) #(#Float #absPrintOn:base: false) #(#Float #initialize false) #(#Form #dotOfSize: false) #(#Form #readNativeResourceFrom: false) #(#GIFReadWriter #exampleAnim false) #(#GZipReadStream #on:from:to: false) #(#GraphMorph #drawDataOn: false) #(#HttpUrl #checkAuthorization:retry: false) #(#ImageSegment #verify:matches:knowing: false) #(#Imports #importImageDirectory: false) #(#Integer #digitDiv:neg: false) #(#Integer #take: false) #(#Interval #valuesInclude: false) #(#JPEGHuffmanTable #makeDerivedTables false) #(#JPEGReadWriter #decodeBlockInto:component:dcTable:acTable: false) #(#KeyedIdentitySet #scanFor: false) #(#LiteralDictionary #scanFor: false) #(#LoopedSampledSound #mixSampleCount:into:startingAt:leftVol:rightVol: false) #(#MIDIInputParser #processByte: false) #(#MIDIScore #insertEvents:at: false) #(#MPEGMoviePlayerMorph #guessVolumeSlider false) #(#MailMessage #bodyTextFormatted false)   #(#MethodDictionary #scanFor: false) #(#MethodFinder #load: false) #(#Morph #addNestedYellowButtonItemsTo:event: false) #(#Morph #addToggleItemsToHaloMenu: false) #(#Morph #duplicateMorphCollection: false) #(#Morph #layoutMenuPropertyString:from: false)  #(#Morph #privateAddAllMorphs:atIndex: false) #(#Morph #specialNameInModel false) #(#MultiByteBinaryOrTextStream #next: false) #(#MultiByteFileStream #next: false) #(#MultiString #indexOfAscii:inMultiString:startingAt: false) #(#MultiString #findMultiSubstring:in:startingAt:matchTable: false) #(#MultiString #multiStringCompare:with:collated: false) #(#MulticolumnLazyListMorph #setColumnWidthsFor: false) #(#NaturalLanguageTranslator #loadAvailableExternalLocales false) #(#NewParagraph #OLDcomposeLinesFrom:to:delta:into:priorLines:atY: false) #(#NewParagraph #selectionRectsFrom:to: false) #(#Object #copyFrom: false) #(#Object #storeOn: false) #(#ObjectExplorer #step false) #(#ObjectOut #xxxFixup false) #(#OldSocket #getResponseNoLF false) #(#OrderedCollection #copyReplaceFrom:to:with: false) #(#PNGReadWriter #copyPixelsGray: false) #(#PNGReadWriter #copyPixelsGrayAlpha: false) #(#PNMReadWriter #nextPutBW:reverse: false) #(#PNMReadWriter #nextPutRGB: false) #(#PNMReadWriter #readBWreverse: false) #(#PNMReadWriter #readPlainRGB false) #(#PRServerDirectory #getPostArgsFromThingsToSearchFor: false) #(#PRServerDirectory #putSmalltalkInfoInto: false) #(#PackageInfo #foreignClasses false) #(#ParagraphEditor #cursorEnd: false) #(#ParseNode #nodePrintOn:indent: false) #(#ParseTreeRewriter #acceptCascadeNode: false) #(#ParseTreeSearcher #messages false) #(#PasteUpMorph #dropFiles: false) #(#PasteUpMorph #mouseDown: false) #(#PhonemeRecord #prunedAverageFeatures: false) #(#PluckedSound #reset false) #(#PluggableDictionary #scanFor: false) #(#PluggableListMorph #list: false) #(#PluggableMultiColumnListMorph #calculateColumnOffsetsFrom: false) #(#PluggableMultiColumnListMorph #calculateColumnWidthsFrom: false) #(#PluggableMultiColumnListMorph #layoutMorphicLists: false) #(#PluggableSet #scanFor: false) #(#PointerFinder #buildList false) #(#PointerFinder #followObject: false) #(#PolygonMorph #derivs:first:second:third: false) #(#PostscriptCanvas #convertFontName: false) #(#PostscriptCanvas #fontSampler false) #(#PostscriptCanvas #postscriptFontInfoForFont: false) #(#PostscriptCanvas #postscriptFontMappingSummary false) #(#PostscriptCanvas #drawGeneralBezierShape:color:borderWidth:borderColor: false) #(#PostscriptCanvas #outlineQuadraticBezierShape: false) #(#ProcessBrowser #dumpTallyOnTranscript: false) #(#ProcessBrowser #processNameList false) #(#ProcessorScheduler #highestPriority: false) #(#ProcessorScheduler #nextReadyProcess false) #(#Project #setFlaps false) #(#ProtoObject #pointsTo: false) #(#RBAssignmentNode #bestNodeFor: false) #(#RBFormatter #formatMessage:cascade: false) #(#RBFormatter #formatStatementCommentFor: false) #(#RBMessageNode #bestNodeFor: false) #(#RBPatternMessageNode #receiver:selectorParts:arguments: false) #(#RBPatternVariableNode #initializePatternVariables false) #(#RBProgramNode #copyList:inContext: false) #(#RBSequenceNode #= false) #(#RBSequenceNode #replaceNode:withNodes: false) #(#RemoteHandMorph #appendNewDataToReceiveBuffer false) #(#RunArray #rangeOf:startingAt: false) #(#SARInstaller #fileIntoChangeSetNamed:fromStream: false) #(#SMLoader #cachePackageReleaseAndOfferToCopy false) #(#SMLoader #downloadPackageRelease false) #(#SMLoader #installPackageRelease: false) #(#SMSqueakMap #accountForName: false) #(#SMSqueakMap #mapInitialsFromMinnow false) #(#SampledSound #convert8bitSignedFrom:to16Bit: false) #(#ScaledDecimalTest #testConvertFromFloat false) #(#ScrollBar #arrowSamples false) #(#ScrollBar #boxSamples false) #(#ScrollBar #doScrollDown false) #(#ScrollBar #doScrollUp false) #(#ScrollBar #scrollDown: false) #(#ScrollBar #scrollUp: false) #(#SecurityManager #flushSecurityKey: false) #(#SelectionMorph #extendByHand: false) #(#Set #do: false) #(#Set #scanFor: false) #(#ShortIntegerArray #writeOn: false) #(#SimpleMIDIPort #closeAllPorts false) #(#SmaCCParser #errorHandlerStates false) #(#SmaCCParser #findErrorHandlerIfNoneUseErrorNumber: false) #(#SmalltalkImage #saveImageSegments: false) #(#SmartRefStream #uniClassInstVarsRefs: false) #(#SoundBuffer #normalized: false) #(#SparseLargeTable #zapDefaultOnlyEntries false) #(#Spline #derivs:first:second:third: false) #(#StrikeFont #bonk:with: false) #(#StrikeFont #buildfontNamed:fromForms:startingAtAscii:ascent:descent:maxWid: false) #(#StrikeFont #makeItalicGlyphs false) #(#StrikeFont #readFromBitFont: false) #(#StrikeFontSet #bonk:with:at: false) #(#StrikeFontSet #displayStringR2L:on:from:to:at:kern: false) #(#StrikeFontSet #makeItalicGlyphs false) #(#String #indexOfAscii:inString:startingAt: false) #(#StringTest #testAsSmalltalkComment false) #(#SymbolTest #testWithFirstCharacterDownshifted false) #(#SyntaxMorph #rename: false) #(#SystemDictionary #makeSqueaklandReleasePhaseFinalSettings false) #(#SystemDictionary #saveImageSegments false) #(#TTCFont #reorganizeForNewFontArray:name: false) #(#TTCFontReader #processCharacterMappingTable: false) #(#TTContourConstruction #segmentsDo: false) #(#TTFontReader #getGlyphFlagsFrom:size: false) #(#TTFontReader #processCharMap: false) #(#TTFontReader #processCharacterMappingTable: false) #(#TTFontReader #processHorizontalMetricsTable:length: false) #(#TestsForTextAndTextStreams #testExampleRunArray5 false) #(#TestsForTextAndTextStreams #testRangeDetection1 false) #(#TestsForTextAndTextStreams #testRangeDetection2 false) #(#TestsForTextAndTextStreams #testRangeDetection3 false) #(#TestsForTextAndTextStreams #testRangeDetection4 false) #(#Text #initTextConstants false) #(#TextConverter #allEncodingNames false) #(#TextStyle #decodeStyleName: false) #(#TextStyle #fontMenuForStyle:target:selector:highlight: false) #(#TextStyle #modalMVCStyleSelectorWithTitle: false) #(#TextStyle #modalStyleSelectorWithTitle: false) #(#TextURL #actOnClickFor: false) #(#ThreePhaseButtonMorph #initialize false) #(#TickIndicatorMorph #drawOn: false) #(#TimeProfileBrowser #setClassAndSelectorIn: false) #(#UCSTable #initializeGB2312Table false) #(#UCSTable #initializeJISX0208Table false) #(#UCSTable #initializeKSX1001Table false) #(#UpdatingStringMorph #decimalPlacesForFloatPrecision: false) #(#UpdatingStringMorph #floatPrecisionForDecimalPlaces: false) #(#WaveEditor #showEnvelope false) #(#WaveletCodec #decodeFrames:from:at:into:at: false) #(#WaveletCodec #encodeFrames:from:at:into:at: false) #(#WeakKeyDictionary #scanFor: false) #(#WeakKeyDictionary #scanForNil: false) #(#WeakSet #scanFor: false) #(#WeakSet #scanForLoadedSymbol: false) #(#WorldState #displayWorldSafely: false) #(#ZLibWriteStream #updateAdler32:from:to:in: false) #(#ZipConstants #initializeDistanceCodes false) #(#ZipWriteStream #dynamicBlockSizeFor:and:using:and: false) #(#ZipWriteStream #fixedBlockSizeFor:and: false) (SimpleMIDIPort closeAllPorts true) (Float initialize true) (FileList2 endingSpec true) (ProcessBrowser dumpTallyOnTranscript: true) (SARInstaller ensurePackageWithId: true) (SARInstaller fileIntoChangeSetNamed:fromStream: true) (Color initializeGrayToIndexMap true) (GIFReadWriter exampleAnim true) (Text initTextConstants true) (String indexOfAscii:inString:startingAt: true)(MultiString indexOfAscii:inString:startingAt: true) (ZLibWriteStream updateAdler32:from:to:in: true) (SampledSound convert8bitSignedFrom:to16Bit: true) (Form dotOfSize: true) (ScrollBar arrowSamples true) (ScrollBar boxSamples true) (DockingBarMorph example3) (UpdatingStringMorph floatPrecisionForDecimalPlaces: true) (PostcriptCanvas postscriptFontMappingSummary true) (PostscriptCanvas convertFontName: true) (PostscriptCanvas fontSampler true) (PostScriptCanvas postscriptFontInfoForFont: true) (TextStyle decodeStyleName true) (TestStyle fontMenuForStyle:target:selector:highlight: true) (TextStyle modalMVCStyleSelectorWithTitle: true)(TextStyle modalStyleSelectorWithTitle: true) (AbstractFont emphasisStringFor: true)
(TTCFonr reorganizeForNewFontArray:name: true) (ZipConstants initializeDistanceCodes true) (UCSTable initializeJISX0208Table true)(UCSTable initializeBG3212Table true)(UCSTable initializeKSX1001Table true) (TextConverter allEncodingNames true))! !

!DecompilerTests methodsFor: 'utilities' stamp: 'JB 10/18/2010 14:49'!
decompilerFailures
       "Here is the list of failures: either a syntax error, a hard error or some failure to decompile correctly.
        Collected via
               DecompilerTestFailuresCollector new computeFailures collect:
                       [:mr| { mr classSymbol. mr selector }]) asArray"
       ^#(     (BrowserCommentTextMorph showPane)
               (ClassDescription replaceSilently:to:)
               (CodeHolder getSelectorAndSendQuery:to:with:)

               (Date printOn:)
               (FileDirectory checkForReadability)

               (Float printPaddedWith:to:)
               (GIFReadWriter nextImageWithPlugin)


               (HttpUrl checkAuthorization:retry:)
               (MCConfigurationBrowser post)
               (MailComposition breakLinesInMessage:)
               (MVCToolBuilder setLayout:in:) "same-name block-local temps in optimized blocks"
               (ParagraphEditor inOutdent:delta:)

               (PNGReadWriter copyPixelsGray:)
               (PointTest testNormal) "fraction printing??"
               (PointTest testTheta) "fraction printing??"
               (ScaledDecimalTest testConvertFromFraction) "local/non-local temps"
               (StandardScriptingSystem holderWithAlphabet) "same-name block-local temps in optimized blocks"
               (SystemWindow convertAlignment)
               (TextEditor inOutdent:delta:)

               (TextURL actOnClickFor:)
               (TTContourConstruction segmentsDo:) "Worth fixing; these two are mistaken conversion from a whileTrue: to a to:do: but the index is used outside the whileTrue:"
               (TTFontReader processHorizontalMetricsTable:length:))! !

!DecompilerTests methodsFor: 'utilities' stamp: 'MarcusDenker 2/19/2010 11:11'!
decompilerTestHelper
	"Decompiles the source for every method in the system, and
	then compiles that source and verifies that it generates (and
	decompiles to) identical code. This currently fails in a number
	of places because some different patterns (esp involving
	conditionals where the first branch returns) decompile the
	same. "
	"self new decompilerTestHelper"
	| methodNode oldMethod newMethod badOnes oldCodeString n |
	badOnes := OrderedCollection new.
	'Decompiling all classes...'
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: CompiledMethod instanceCount
		during: [:bar | 
			n := 0.
			self systemNavigation
				allBehaviorsDo: [:cls | 
					(self isBlockingClass: cls)
						ifFalse: [
					Smalltalk garbageCollect.
					Transcript cr; show: cls name.
					cls selectors
						do: [:selector | 
							(n := n + 1) \\ 100 = 0
								ifTrue: [bar value: n].
							(self isFailure: cls sel: selector)
								ifFalse: [oldMethod := cls compiledMethodAt: selector.
									oldCodeString := (cls decompilerClass new
												decompile: selector
												in: cls
												method: oldMethod) decompileString.
									methodNode := cls compilerClass new
												compile: oldCodeString
												in: cls
												notifying: nil
												ifFail: [].
									newMethod := methodNode generate.
									oldCodeString = (cls decompilerClass new
												decompile: selector
												in: cls
												method: newMethod) decompileString
										ifFalse: [Transcript cr; show: '***' , cls name , ' ' , selector.
											badOnes add: cls name , ' ' , selector]]]]]].
	self systemNavigation browseMessageList: badOnes asSortedCollection name: 'Decompiler Discrepancies'! !

!DecompilerTests methodsFor: 'utilities' stamp: 'sd 9/25/2004 15:30'!
isBlockingClass: cls 
	"self new isBlockingClass: PNMReaderWriter"

	^ self blockingClasses includes: cls name asSymbol
! !

!DecompilerTests methodsFor: 'utilities' stamp: 'sd 9/25/2004 15:29'!
isFailure: cls sel: selector 
	"self new isKnowProblem: PNMReaderWriter sel: #nextImage"
	"#((PNMReadWriter nextImage)) includes: {PNMReadWriter
	name asSymbol . #nextImage}."
	^ self decompilerFailures includes: {cls name asSymbol. selector}! !

!DecompilerTests methodsFor: 'utilities' stamp: 'sd 9/25/2004 21:28'!
isStoredProblems: cls sel: selector meta: aBoolean
	"self new isKnowProblem: PNMReaderWriter sel: #nextImage"
	
	^ self decompilerDiscrepancies includes: {cls name asSymbol. selector . aBoolean}! !

!DecompilerTests methodsFor: 'testing' stamp: 'MarcusDenker 2/19/2010 11:11'!
testDecompiler
	"self run: #testDecompiler"
	"self debug: #testDecompiler"
	| methodNode oldMethod newMethod oldCodeString |
	self systemNavigation
		allBehaviorsDo: [:cls | (self isBlockingClass: cls)
				ifFalse: [Smalltalk garbageCollect.
					cls selectors
						do: [:selector | (self isFailure: cls sel: selector)
								ifFalse: [" to help making progress
										(self
											isStoredProblems: cls theNonMetaClass
											sel: selector
											meta: cls isMeta)
										ifFalse: [ "
										Transcript cr; show: cls name.
											oldMethod := cls compiledMethodAt: selector.
											oldCodeString := (cls decompilerClass new
														decompile: selector
														in: cls
														method: oldMethod) decompileString.
											methodNode := cls compilerClass new
														compile: oldCodeString
														in: cls
														notifying: nil
														ifFail: [].
											newMethod := methodNode generate.
											self assert: oldCodeString = (cls decompilerClass new
														decompile: selector
														in: cls
														method: newMethod) decompileString
												description: cls name asString, ' ', selector asString
												resumable: true.
												
													]]]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesAAtoAM
	self decompileClassesSelect: [:cn| cn first = $A and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesANtoAZ
	self decompileClassesSelect: [:cn| cn first = $A and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesBAtoBM
	self decompileClassesSelect: [:cn| cn first = $B and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesBNtoBZ
	self decompileClassesSelect: [:cn| cn first = $B and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesCAtoCM
	self decompileClassesSelect: [:cn| cn first = $C and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesCNtoCZ
	self decompileClassesSelect: [:cn| cn first = $C and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesDAtoDM
	self decompileClassesSelect: [:cn| cn first = $D and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesDNtoDZ
	self decompileClassesSelect: [:cn| cn first = $D and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesEAtoEM
	self decompileClassesSelect: [:cn| cn first = $E and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesENtoEZ
	self decompileClassesSelect: [:cn| cn first = $E and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesFAtoFM
	self decompileClassesSelect: [:cn| cn first = $F and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesFNtoFZ
	self decompileClassesSelect: [:cn| cn first = $F and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesGAtoGM
	self decompileClassesSelect: [:cn| cn first = $G and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesGNtoGZ
	self decompileClassesSelect: [:cn| cn first = $G and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesHAtoHM
	self decompileClassesSelect: [:cn| cn first = $H and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesHNtoHZ
	self decompileClassesSelect: [:cn| cn first = $H and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesIAtoIM
	self decompileClassesSelect: [:cn| cn first = $I and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesINtoIZ
	self decompileClassesSelect: [:cn| cn first = $I and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesJAtoJM
	self decompileClassesSelect: [:cn| cn first = $J and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesJNtoJZ
	self decompileClassesSelect: [:cn| cn first = $J and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesKAtoKM
	self decompileClassesSelect: [:cn| cn first = $K and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesKNtoKZ
	self decompileClassesSelect: [:cn| cn first = $K and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesLAtoLM
	self decompileClassesSelect: [:cn| cn first = $L and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesLNtoLZ
	self decompileClassesSelect: [:cn| cn first = $L and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesMAtoMM
	self decompileClassesSelect: [:cn| cn first = $M and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesMNtoMZ
	self decompileClassesSelect: [:cn| cn first = $M and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesNAtoNM
	self decompileClassesSelect: [:cn| cn first = $N and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesNNtoNZ
	self decompileClassesSelect: [:cn| cn first = $N and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesOAtoOM
	self decompileClassesSelect: [:cn| cn first = $O and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesONtoOZ
	self decompileClassesSelect: [:cn| cn first = $O and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesPAtoPM
	self decompileClassesSelect: [:cn| cn first = $P and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesPNtoPZ
	self decompileClassesSelect: [:cn| cn first = $P and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesQAtoQM
	self decompileClassesSelect: [:cn| cn first = $Q and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesQNtoQZ
	self decompileClassesSelect: [:cn| cn first = $Q and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesRAtoRM
	self decompileClassesSelect: [:cn| cn first = $R and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesRNtoRZ
	self decompileClassesSelect: [:cn| cn first = $R and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesSAtoSM
	self decompileClassesSelect: [:cn| cn first = $S and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesSNtoSZ
	self decompileClassesSelect: [:cn| cn first = $S and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesTAtoTM
	self decompileClassesSelect: [:cn| cn first = $T and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesTNtoTZ
	self decompileClassesSelect: [:cn| cn first = $T and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesUAtoUM
	self decompileClassesSelect: [:cn| cn first = $U and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesUNtoUZ
	self decompileClassesSelect: [:cn| cn first = $U and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesVAtoVM
	self decompileClassesSelect: [:cn| cn first = $V and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesVNtoVZ
	self decompileClassesSelect: [:cn| cn first = $V and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesWAtoWM
	self decompileClassesSelect: [:cn| cn first = $W and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesWNtoWZ
	self decompileClassesSelect: [:cn| cn first = $W and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesXAtoXM
	self decompileClassesSelect: [:cn| cn first = $X and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesXNtoXZ
	self decompileClassesSelect: [:cn| cn first = $X and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesYAtoYM
	self decompileClassesSelect: [:cn| cn first = $Y and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesYNtoYZ
	self decompileClassesSelect: [:cn| cn first = $Y and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesZAtoZM
	self decompileClassesSelect: [:cn| cn first = $Z and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesZNtoZZ
	self decompileClassesSelect: [:cn| cn first = $Z and: [cn second asUppercase > $M]]! !

Object subclass: #TotalCost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!TotalCost commentStamp: 'StephaneDucasse 6/9/2010 20:53' prior: 0!
Part of an test resource to verify that super is well bound.
See CompilerEvaluationTest!

TotalCost subclass: #AverageCost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!AverageCost commentStamp: 'StephaneDucasse 6/9/2010 20:53' prior: 0!
Part of an test resource to verify that super is well bound.
See CompilerEvaluationTest!

!AverageCost methodsFor: 'as yet unclassified' stamp: 'NikoSchwarz 6/5/2010 16:11'!
total

	^super total / 12! !

AverageCost subclass: #WeightedAverageCost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompilerTests'!

!WeightedAverageCost commentStamp: 'StephaneDucasse 6/9/2010 20:53' prior: 0!
Part of an test resource to verify that super is well bound.
See CompilerEvaluationTest!

!TotalCost methodsFor: 'as yet unclassified' stamp: 'NikoSchwarz 6/5/2010 15:53'!
total
	^25000 ! !
